-- Get objects from orxonox
thisscript:addObject("GenericNPC", "secondguard")
thisscript:addObject("GenericNPC", "guard")
thisscript:addObject("FPSPlayer", "Player")
thisscript:addObject("GenericNPC", "prisoner")

-- Global Variables
allOk = true
cellReached = false
guidePositionReached = false
prisonerReachedLock = false
hangarReached = false
guardStopped = false

height = 90

-- Returns the distance between (x1,x2,x3) and (y1,y2,y3)
function dist( x1,x2,x3, y1,y2,y3 )
return math.sqrt( (x1-y1)^2 + (x2-y2)^2 + (x3-y3)^2 )
end


function observeGuard()
guardX = guard:getAbsCoorX()
guardY = guard:getAbsCoorY()
guardZ = guard:getAbsCoorZ()

if dist( guardX,guardY,guardZ,35.48, 29, 191.28 ) < 30 then
allOk = false
end

end

function observePlayer()

guardX = guard:getAbsCoorX()
guardY = guard:getAbsCoorY()
guardZ = guard:getAbsCoorZ()

playerX = Player:getAbsCoorX()
playerY = Player:getAbsCoorY()
playerZ = Player:getAbsCoorZ()

distance = dist( guardX,guardY,guardZ,playerX, playerY, playerZ)

if distance > 250 and hangarProgrammed and not guardStopped then
 secondguard:stop()
 guardStopped = true
end

if distance < 250 and hangarProgrammed and guardStopped then
 secondguard:resume()
 guardStopped = false
end

end



function observePrisoner()

prisonerX = prisoner:getAbsCoorX()
prisonerY = prisoner:getAbsCoorY()
prisonerZ = prisoner:getAbsCoorZ()

if dist( prisonerX,prisonerY,prisonerZ,162.757919,49,363.489349 ) < 60 then
--io.write("Prisonner reached lock \n")
prisonerReachedLock = true
end

end

cellProgrammed = false
function goToCell(timestep)

if not cellProgrammed then
secondguard:walkTo( 442.173767, height, 176.429855)
secondguard:walkTo( 442.173767, height, 176.429855)
secondguard:walkTo( 436.727753, height, 188.191757)
secondguard:walkTo( 432.311584, height, 198.882462)
secondguard:walkTo( 426.079590, height, 213.968994)
secondguard:walkTo( 420.553986, height, 226.714996)
secondguard:walkTo( 412.681915, height, 235.053696)
secondguard:walkTo( 398.758545, height, 241.846924)
secondguard:walkTo( 384.690735, height, 242.851395)
secondguard:walkTo( 348.930481, height, 242.394958)
secondguard:walkTo( 336.467926, height, 241.985764)
secondguard:walkTo( 324.042999, height, 241.577774)
secondguard:walkTo( 303.851410, height, 240.914841)
secondguard:walkTo( 293.013977, height, 240.559006)
secondguard:walkTo( 276.207611, height, 240.007233)
secondguard:walkTo( 261.475800, height, 239.523544)
secondguard:walkTo( 239.185089, height, 238.791687)
secondguard:walkTo( 226.655655, height, 238.491974)
secondguard:walkTo( 211.996979, height, 238.851044)
secondguard:walkTo( 192.956741, height, 239.859207)
secondguard:walkTo( 178.496552, height, 241.852539)
secondguard:walkTo( 160.421860, height, 244.009827)
secondguard:walkTo( 145.371857, height, 244.946075)
secondguard:walkTo( 129.918198, height, 245.307037)
secondguard:walkTo( 113.065468, height, 245.108231)
secondguard:walkTo( 99.159073, height, 244.695694)
secondguard:walkTo( 82.069923, height, 244.188766)
secondguard:walkTo( 65.880531, height, 243.708527)
secondguard:walkTo( 48.133881, height, 243.182114)
secondguard:walkTo( 34.706280, height, 242.783813)
secondguard:walkTo( 20.682344, height, 242.367783)
secondguard:walkTo( 5.419819, height, 241.915070)
secondguard:walkTo( -10.556346, height, 241.058746)
secondguard:walkTo( -24.159513, height, 240.127090)
secondguard:walkTo( -33.819145, height, 239.995453)
secondguard:walkTo( -45.414162, height, 240.373322)
secondguard:walkTo( -60.228550, height, 240.856079)
secondguard:walkTo( -73.269897, height, 241.260895)
secondguard:walkTo( -86.128647, height, 240.457886)
secondguard:walkTo( -100.443581, height, 236.485718)
secondguard:walkTo( -112.346939, height, 233.967209)
secondguard:walkTo( -127.331635, height, 227.615112)
secondguard:walkTo( -135.153656, height, 215.476883)
secondguard:walkTo( -131.529984, height, 202.931015)
secondguard:walkTo( -122.671799, height, 193.644669)
secondguard:walkTo( -113.823517, height, 183.986633)
secondguard:walkTo( -104.089592, height, 170.659729)
cellProgrammed = true
end

if secondguard:finalGoalReached() then
return true
end

return false
end

guideProgrammed = false
function goToGuidePosition(timestep)

if not guideProgrammed then
secondguard:walkTo( -100.266739, height, 171.345627)
secondguard:walkTo( -91.152046, height, 171.639709)
secondguard:walkTo( -85.456375, height, 171.823486)
secondguard:walkTo( -74.048538, height, 172.191589)
secondguard:walkTo( -53.574173, height, 172.852219)
secondguard:walkTo( -43.275124, height, 173.184540)
secondguard:walkTo( -35.155544, height, 173.446518)
secondguard:walkTo( -31.645050, height, 173.559784)
secondguard:walkTo( -23.426588, height, 173.824966)
secondguard:walkTo( -10.576803, height, 174.239578)
secondguard:walkTo( -2.389911, height, 174.503754)
secondguard:walkTo( 6.950986, height, 174.805176)
secondguard:walkTo( 16.313608, height, 175.161179)
secondguard:walkTo( 23.271458, height, 175.547226)
secondguard:walkTo( 31.248058, height, 176.199890)
secondguard:walkTo( 43.694778, height, 177.753479)
secondguard:walkTo( 50.441612, height, 178.595612)
secondguard:walkTo( 71.374535, height, 181.208389)
secondguard:walkTo( 82.251022, height, 181.855988)
secondguard:walkTo( 91.975792, height, 182.434998)
secondguard:walkTo( 101.695015, height, 183.013672)
secondguard:walkTo( 110.377205, height, 183.530609)
secondguard:walkTo( 122.299400, height, 184.240448)
secondguard:walkTo( 129.848495, height, 184.689911)
secondguard:walkTo( 141.687805, height, 185.394821)
secondguard:walkTo( 150.166702, height, 186.776016)
secondguard:walkTo( 155.342255, height, 189.285080)
secondguard:walkTo( 162.508133, height, 192.849976)
secondguard:walkTo( 171.747696, height, 197.075134)
secondguard:walkTo( 177.846390, height, 199.864029)
secondguard:walkTo( 182.707596, height, 204.381516)
secondguard:walkTo( 182.707596, height, 204.381516)
secondguard:walkTo( 187.317139, height, 211.966385)
secondguard:walkTo( 193.191528, height, 221.632446)
secondguard:walkTo( 197.856018, height, 229.307724)
secondguard:walkTo( 198.350906, height, 232.634857)
secondguard:walkTo( 198.427155, height, 243.656113)

guideProgrammed = true
end

if secondguard:finalGoalReached() then
return true
end

return false
end

hangarProgrammed = false
function goToHangar(timestep)

if not hangarProgrammed and prisonerReachedLock then
secondguard:walkTo( 198.984589, height, 243.144440)
secondguard:walkTo( 188.270493, height, 242.143143)
secondguard:walkTo( 185.177658, height, 241.854080)
secondguard:walkTo( 166.990906, height, 249.598251)
secondguard:walkTo( 160.702652, height, 251.610641)
secondguard:walkTo( 157.542480, height, 260.691101)
secondguard:walkTo( 158.720688, height, 285.526489)
secondguard:walkTo( 158.819519, height, 295.229065)
secondguard:walkTo( 158.941727, height, 307.225800)
secondguard:walkTo( 159.095718, height, 322.344818)
secondguard:walkTo( 159.248337, height, 332.535400)
secondguard:walkTo( 159.600082, height, 343.361420)
secondguard:walkTo( 160.006805, height, 355.880432)
secondguard:walkTo( 161.582108, height, 441.998688)
secondguard:walkTo( 161.650970, height, 447.407074)
secondguard:walkTo( 161.755173, height, 455.592651)
secondguard:walkTo( 162.311462, height, 471.569611)
secondguard:walkTo( 164.966690, height, 482.971222)
secondguard:walkTo( 168.578796, height, 492.256317)
secondguard:walkTo( 204.727936, height, 507.833527)
secondguard:walkTo( 212.031540, height, 508.235596)
secondguard:walkTo( 226.355484, height, 509.024170)
secondguard:walkTo( 441.672638, height, 512.266846)
secondguard:walkTo( 509.640350, height, 512.965515)
secondguard:walkTo( 576.208435, height, 512.614258)
secondguard:walkTo( 638.251770, height, 512.247986)
secondguard:walkTo( 667.897888, height, 512.072693)
secondguard:walkTo( 683.874451, height, 511.978363)
secondguard:walkTo( 693.377319, height, 511.922302)
secondguard:walkTo( 700.632446, height, 511.837494)
secondguard:walkTo( 703.564148, height, 511.713562)
secondguard:walkTo( 710.958313, height, 510.896362)
secondguard:walkTo( 724.824585, height, 502.160461)
secondguard:walkTo( 728.256226, height, 497.817627)
secondguard:walkTo( 734.361206, height, 484.795380)
secondguard:walkTo( 737.112488, height, 478.616089)
secondguard:walkTo( 740.696350, height, 470.796539)
secondguard:walkTo( 743.915833, height, 462.804688)
secondguard:walkTo( 750.241150, height, 438.829529)
secondguard:walkTo( 751.186340, height, 432.598022)
secondguard:walkTo( 751.977051, height, 427.385315)
secondguard:walkTo( 756.962708, height, 379.979919)
secondguard:walkTo( 759.845581, height, 337.377167)
secondguard:walkTo( 762.304626, height, 288.355713)
secondguard:walkTo( 764.125244, height, 248.893723)
secondguard:walkTo( 766.738892, height, 164.214142)
secondguard:walkTo( 767.405884, height, 116.896973)
secondguard:walkTo( 767.289917, height, 68.270233)
secondguard:walkTo( 767.680176, height, 31.480713)
secondguard:walkTo( 767.315247, height, -46.728809)
secondguard:walkTo( 767.634888, height, -85.314407)
secondguard:walkTo( 767.905823, height, -112.270973)
secondguard:walkTo( 767.716003, height, -134.956741)
secondguard:walkTo( 765.699829, height, -159.042664)
secondguard:walkTo( 762.026978, height, -178.211639)
secondguard:walkTo( 751.512512, height, -219.904297)
secondguard:walkTo( 735.898499, height, -277.525970)
secondguard:walkTo( 722.206055, height, -329.591888)
secondguard:walkTo( 709.354858, height, -383.514618)
secondguard:walkTo( 697.115295, height, -434.870483)
secondguard:walkTo( 685.142822, height, -485.212402)
secondguard:walkTo( 681.659058, height, -532.429504)
secondguard:walkTo( 679.999634, height, -581.595886)
secondguard:walkTo( 678.678101, height, -632.772156)
secondguard:walkTo( 678.162842, height, -682.753113)
secondguard:walkTo( 678.398376, height, -731.779053)
secondguard:walkTo( 679.124756, height, -782.160034)
secondguard:walkTo( 680.050781, height, -831.132141)
secondguard:walkTo( 678.395569, height, -877.242920)
secondguard:walkTo( 676.737793, height, -919.301819)
secondguard:walkTo( 676.191956, height, -962.443909)
secondguard:walkTo( 676.493774, height, -994.707703)
secondguard:walkTo( 677.446716, height, -1018.486389)
secondguard:walkTo( 681.286865, height, -1042.623901)
secondguard:walkTo( 685.302917, height, -1060.096436)
secondguard:walkTo( 692.212036, height, -1083.229370)
secondguard:walkTo( 698.947937, height, -1103.496826)
secondguard:walkTo( 710.392944, height, -1137.932617)
secondguard:walkTo( 719.685608, height, -1164.374634)
secondguard:walkTo( 728.124512, height, -1186.812622)
secondguard:walkTo( 746.270569, height, -1235.059082)
secondguard:walkTo( 754.436340, height, -1259.201660)
secondguard:walkTo( 760.588013, height, -1286.830933)
secondguard:walkTo( 765.026733, height, -1329.641113)
secondguard:walkTo( 765.849609, height, -1362.461670)
secondguard:walkTo( 765.842346, height, -1398.791016)
secondguard:walkTo( 765.749695, height, -1425.336304)
secondguard:walkTo( 765.650024, height, -1454.007935)
hangarProgrammed = true
end

guardX = secondguard:getAbsCoorX()
guardY = secondguard:getAbsCoorY()
guardZ = secondguard:getAbsCoorZ()

if dist( guardX,guardY,guardZ, 2.861493, 29, -1705.131958) < 60 then
return true
end

return false

end

time = 2
function tick(timestep)
--io.write("Secondguard called \n")
 
observePrisoner()
observeGuard()
observePlayer()

if not allOk then
cellReached = goToCell(timestep)
end

--do talking
if cellReached then
time = time - timestep
end


if time < 0 then

if cellReached and not guidePositionReached then
guidePositionReached = goToGuidePosition(timestep)
end

if guidePositionReached and not hangarReached then
hangarReached = goToHangar(timestep)
end

if hangarReached then
return true
end


end


return false
end